//------------------------------------------------------------------------------
/// @file  p9_sbe_npll_initf.H
///
/// @brief apply initfile for level 0 & 1 PLLs
// *!
// *! OWNER NAME  : Abhishek Agarwal  Email: abagarw8@in.ibm.com
// *! BACKUP NAME :                   Email:
//------------------------------------------------------------------------------
// *HWP HWP Owner   : Abhishek Agarwal <abagarw8@in.ibm.com>
// *HWP FW Owner    : Brian Silver <bsilver@us.ibm.com>
// *HWP Team        : Perv
// *HWP Level       : 1
// *HWP Consumed by : SBE
//------------------------------------------------------------------------------


#ifndef _P9_SBE_NPLL_INITF_H_
#define _P9_SBE_NPLL_INITF_H_


#include <fapi2.H>


typedef fapi2::ReturnCode (*p9_sbe_npll_initf_FP_t)(const
        fapi2::Target<fapi2::TARGET_TYPE_PROC_CHIP> &);

/// @brief --run scan0 module  (scan region = PLL, scan_types = GPTR)
/// --run scan0 module  (scan region = PLL, scan_types = BNDY/FUNC)
/// --Scan initialize PLL BNDY chain (chiplet = PERV, scan ring = PLL, scan type = BNDY)
///
///
/// @param[in]     i_target_chip   Reference to TARGET_TYPE_PROC_CHIP target
/// @return  FAPI2_RC_SUCCESS if success, else error code.
extern "C"
{
    fapi2::ReturnCode p9_sbe_npll_initf(const
                                        fapi2::Target<fapi2::TARGET_TYPE_PROC_CHIP> & i_target_chip);
}

#endif
